{
  "namespace": "ultimate_crafting_table",

  "tab_panel": {
    "type": "stack_panel",
    "size": ["100%",
      "100%c"],
    "anchor_from": "top_middle",
    "anchor_to": "top_middle"
  },
  "button_toggle_unchecked": {
    "type": "image",
    "texture": "textures/ultimate_crafting/ui/ultimate_crafting_toggle_unchecked",
    "size": ["100%",
      "100%"],
    "layer": 2,
    "controls": [{
      "icon@ultimate_crafting_table.toggle_button_control": {}
    }]
  },
  "button_toggle_checked": {
    "type": "image",
    "texture": "textures/ultimate_crafting/ui/ultimate_crafting_toggle_checked",
    "size": ["100%",
      "100%"],
    "controls": [{
      "icon@ultimate_crafting_table.toggle_button_control": {}
    }]
  },
  "item_icon_renderer": {
    "type": "custom",
    "renderer": "inventory_item_renderer",
    "size": [
      16,
      16
    ],
    "layer": 3
  },
  "toggle_button_control": {
    "type": "panel",
    "layer": 3,
    "size": [
      18,
      18
    ],
    "controls": [{
      "chest_icon_front": {
        "type": "image",
        "size": [
          16,
          16
        ],
        "texture": "$path"
      }
    }]
  },
  "section_toggle_button": {
    "type": "panel",
    "anchor_from": "top_left",
    "anchor_to": "top_left",
    "size": [
      23,
      22.9
    ],
    "controls": [{
      "section_toggle_button@common_toggles.light_ui_toggle": {
        "anchor_from": "top_left",
        "anchor_to": "top_left",
        "size": [
          18,
          18
        ],
        "$default_selector_toggle_index": 0,
        "$button_type_panel": "ultimate_crafting_table.toggle_button_control",
        "$checked_control": "ultimate_crafting_table.button_toggle_checked",
        "$unchecked_control": "ultimate_crafting_table.button_toggle_unchecked",
        "$unchecked_hover_control": "ultimate_crafting_table.button_toggle_unchecked",
        "$checked_hover_control": "ultimate_crafting_table.button_toggle_checked",
        "$path": "$icon_path",
        "$radio_toggle_group": true,
        "$toggle_name": "navigation_tab",
        "$toggle_group_default_selected": "$default_selector_toggle_index",

        "$toggle_tab_focus_binding_type": "global",
        "$toggle_tab_focus_binding_name": "#navigation_tab_focus_precedence",
        "$toggle_on_hover_binding_type": "global",
        "$toggle_on_hover_binding_name": "#toggle_on_hover",

        "$toggle_view_binding_name": "($section_topic + '_button_toggle')",
        "$toggle_property_bag": {
          "#panel_title": "('howtoplay.' + $section_topic)"
        }
      }
    }]
  },
  "not_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "notTab",
    "$icon_path": "textures/blocks/barrier"
  },
  "sword_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "swordTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_sword"
  },
  "pickaxe_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "pickaxeTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_pickaxe"
  },
  "axe_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "axeTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_axe"
  },
  "shovel_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "shovelTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_shovel"
  },
  "hoe_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "hoeTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_hoe"
  },
  "helmet_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "helmetTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_helmet"
  },
  "chestplate_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "chestplateTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_chestplate"
  },
  "leggings_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "leggingsTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_leggings"
  },
  "boots_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "bootsTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_boots"
  },
  "csing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "csingTab",
    "$icon_path": "textures/ultimate_crafting/coal_singularity"
  },
  "ising_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "isingTab",
    "$icon_path": "textures/ultimate_crafting/iron_singularity"
  },
  "gsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "gsingTab",
    "$icon_path": "textures/ultimate_crafting/gold_singularity"
  },
  "dsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "dsingTab",
    "$icon_path": "textures/ultimate_crafting/diamond_singularity"
  },
  "esing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "esingTab",
    "$icon_path": "textures/ultimate_crafting/emerald_singularity"
  },
  "cpsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "cpsingTab",
    "$icon_path": "textures/ultimate_crafting/copper_singularity"
  },
  "rsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "rsingTab",
    "$icon_path": "textures/ultimate_crafting/redstone_singularity"
  },
  "nsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "nsingTab",
    "$icon_path": "textures/ultimate_crafting/netherite_singularity"
  },
  "lsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "lsingTab",
    "$icon_path": "textures/ultimate_crafting/lapis_singularity"
  },
  "ultsing_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "ultsingTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_singularity"
  },
  "ultingot_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "ultingotTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_ingot"
  },
  "ultbwand_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "ultbwandTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_builder_wand"
  },
  "ultdwand_tab@ultimate_crafting_table.section_toggle_button": {
    "$section_topic": "ultdwandTab",
    "$icon_path": "textures/ultimate_crafting/ultimate_destruction_wand"
  },
  "ultimate_crafting_table_item@common.container_item": {
    "$item_collection_name":"container_items",
    "size":[
      14,
      14
    ]
  },
  "ultimate_crafting_table@common.dialog_background_common": {
    "texture": "textures/ultimate_crafting/ui/ultimate_crafting_table",
    "layer": 1
  },
  "inputs": {
    "type": "grid",
    "size": [
      90,
      90
    ],
    "anchor_from": "top_right",
    "anchor_to": "top_right",
    "grid_dimensions": [
      5,
      5
    ],
    "grid_item_template": "chest.chest_grid_item",
    "collection_name":"container_items"
  },
  "output": {
    "type": "grid",
    "size": [
      "100%",
      "100%"
    ],
    "anchor_from": "top_left",
    "anchor_to": "top_left",
    "grid_dimensions": [
      36,
      1
    ],
    "$grid_position|default": [
      0,
      0
    ],
    "collection_name":"container_items",
    "$cell_background|default": "common.cell_image",
    "controls":[{
      "output@ultimate_crafting_table.ultimate_crafting_table_item": {
        "grid_position": "$grid_position",
        "$background_images": "$cell_background",
        "size": [
          26,
          26
        ],
        "$cell_image_size": [
          26,
          26
        ]
      }
    }]
  },

  "tabs_toggles": {
    "type": "stack_panel",
    "orientation": "vertical",
    "size": [
      128,
      22
    ],
    "$default_selector_toggle_index|default": 0,
    "controls": [{
      "column1": {
        "type": "stack_panel",
        "orientation": "horizontal",
        "controls": [{
          "not@ultimate_crafting_table.not_tab": {
            "$toggle_group_forced_index": 0
          }
        },
          {
            "sword@ultimate_crafting_table.sword_tab": {
              "$toggle_group_forced_index": 1
            }
          },
          {
            "pickaxe@ultimate_crafting_table.pickaxe_tab": {
              "$toggle_group_forced_index": 2
            }
          },
          {
            "axe@ultimate_crafting_table.axe_tab": {
              "$toggle_group_forced_index": 3
            }
          },
          {
            "shovel@ultimate_crafting_table.shovel_tab": {
              "$toggle_group_forced_index": 4
            }
          },
          {
            "hoe@ultimate_crafting_table.hoe_tab": {
              "$toggle_group_forced_index": 5
            }
          }]
      }
    },
      {
        "column2": {
          "type": "stack_panel",
          "orientation": "horizontal",
          "controls": [{
            "helmet@ultimate_crafting_table.helmet_tab": {
              "$toggle_group_forced_index": 6
            }
          },
          {
           "chestplate@ultimate_crafting_table.chestplate_tab": {
              "$toggle_group_forced_index": 7
            }
           },
           {
           "leggings@ultimate_crafting_table.leggings_tab": {
              "$toggle_group_forced_index": 8
            }
           },
           {
           "boots@ultimate_crafting_table.boots_tab": {
              "$toggle_group_forced_index": 9
            }
           },
           {
           "csing@ultimate_crafting_table.csing_tab": {
              "$toggle_group_forced_index": 10
            }
           },
           {
           "ising@ultimate_crafting_table.ising_tab": {
              "$toggle_group_forced_index": 11
            }
           }]
        }
      },
      {
     "column3": {
          "type": "stack_panel",
          "orientation": "horizontal",
          "controls": [{
           "gsing@ultimate_crafting_table.gsing_tab": {
              "$toggle_group_forced_index": 12
            }
           },
           {
           "dsing@ultimate_crafting_table.dsing_tab": {
              "$toggle_group_forced_index": 13
            }
           },
           {
           "esing@ultimate_crafting_table.esing_tab": {
              "$toggle_group_forced_index": 14
            }
           },
           {
           "cpsing@ultimate_crafting_table.cpsing_tab": {
              "$toggle_group_forced_index": 15
            }
           },
          {
           "rsing@ultimate_crafting_table.rsing_tab": {
              "$toggle_group_forced_index": 16
            }
           },
           {
           "nsing@ultimate_crafting_table.nsing_tab": {
              "$toggle_group_forced_index": 17
            }
           }]
        }
      },
      {
      "column4": {
          "type": "stack_panel",
          "orientation": "horizontal",
          "controls": [{
           "lsing@ultimate_crafting_table.lsing_tab": {
              "$toggle_group_forced_index": 18
            }
           },
           {
           "ultsing@ultimate_crafting_table.ultsing_tab": {
              "$toggle_group_forced_index": 19
            }
           },
           {
           "ultingot@ultimate_crafting_table.ultingot_tab": {
              "$toggle_group_forced_index": 20
            }
           },
           {
           "ultbwand@ultimate_crafting_table.ultbwand_tab": {
              "$toggle_group_forced_index": 21
            }
           },
           {
            "ultdwand@ultimate_crafting_table.ultdwand_tab": {
              "$toggle_group_forced_index": 22
            }
            }]
        }
      }]
  },

  "ultimate_crafting_table_grid": {
    "type": "panel",
    "anchor_from": "left_middle",
    "anchor_to": "left_middle",
    "offset": [
      0,
      "1%"
    ],
    "size": [
      5,
      5
    ],
    "controls": [{
      "sword": {
        "type": "image",
        "size": [
          180,
          186
        ],
        "bindings": [{
          "binding_type": "view",
          "source_control_name": "('swordTab_button_toggle')",
          "source_property_name": "#toggle_state",
          "target_property_name": "#visible"
        }],
        "texture": "textures/ultimate_crafting/ui/ultimate_sword_crafting",
        "layer": 5,
        "offset": [
          80.5,
          25.5
        ]
      }
    },
      {
        "pickaxe": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('pickaxeTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_pickaxe_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "axe": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('axeTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_axe_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "shovel": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('shovelTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_shovel_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "hoe": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('hoeTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_hoe_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "helmet": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('helmetTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_helmet_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "chestplate": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('chestplateTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_chestplate_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "leggings": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('leggingsTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_leggings_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "boots": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('bootsTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_boots_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "csing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('csingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/csing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "ising": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('isingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ising_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "gsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('gsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/gsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
         "dsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('dsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/dsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "esing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('esingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/esing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "cpsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('cpsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/cpsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "rsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('rsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/rsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "nsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('nsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/nsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "lsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('lsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/lsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "ultsing": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('ultsingTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultsing_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "ultingot": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('ultingotTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_ingot_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "ultimate_b_wand": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('ultbwandTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_b_wand_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "ultimate_d_wand": {
          "type": "image",
          "size": [
            180,
            186
          ],
          "bindings": [{
            "binding_type": "view",
            "source_control_name": "('ultdwandTab_button_toggle')",
            "source_property_name": "#toggle_state",
            "target_property_name": "#visible"
          }],
          "texture": "textures/ultimate_crafting/ui/ultimate_d_wand_crafting",
          "layer": 5,
          "offset": [
            80.5,
            25.5
          ]
        }
      },
      {
        "slot_0@ultimate_crafting_table.inputs": {
          "offset": [
            89,
            -59
          ]
        }
      },
      {
        "slot_1@ultimate_crafting_table.output": {
          "offset": [
            128,
            -27
          ],
          "$grid_position": [
            25,
            0
          ],
          "$cell_background": "common.cell_image"
        }
      }]
  },
  "ultimate_crafting_table_controller": {
    "type": "panel",
    "size": [
      "100%",
      "50%"
    ],
    "offset": [
      0,
      11
    ],
    "anchor_to": "top_left",
    "anchor_from": "top_left",
    "controls": [{
      "content@ultimate_crafting_table.tabs_toggles": {
        "offset": [
          160,
          -10
        ]
      }
    },
      {
        "slots@ultimate_crafting_table.ultimate_crafting_table_grid": {
          "offset": [
            7,
            10
          ]
        }
      }]
  },
  "ultimate_crafting_table_root_panel@common.root_panel": {
    "size": [
      180,
      186
    ],
    "layer": 1,
    "controls": [{
      "common_panel@common.common_panel": {
        "$dialog_background|default": "ultimate_crafting_table.ultimate_crafting_table"
      }
    },
      {
        "chest_panel": {
          "type": "panel",
          "layer": 5,
          "controls": [{
            "controller@ultimate_crafting_table.ultimate_crafting_table_controller": {}
          },
            {
              "inventory_panel_bottom_half_with_label@common.inventory_panel_bottom_half_with_label": {
                "ignored": false
              }
            },
            {
              "hotbar_grid@common.hotbar_grid_template": {}
            },
            {
              "inventory_take_progress_icon_button@common.inventory_take_progress_icon_button": {}
            }]
        }
      },
      {
        "inventory_selected_icon_button@common.inventory_selected_icon_button": {}
      },
      {
        "gamepad_cursor@common.gamepad_cursor_button": {}
      }]
  },
  "ultimate_crafting_table_panel": {
    "type": "panel",
    "controls": [{
      "container_gamepad_helpers@common.container_gamepad_helpers": {}
    },
      {
        "flying_item_renderer@common.flying_item_renderer": {
          "layer": 11
        }
      },
      {
        "selected_item_details_factory@common.selected_item_details_factory": {
          "control_name": "@chest.selected_item_details"
        }
      },
      {
        "item_lock_notification_factory@common.item_lock_notification_factory": {
          "control_name": "@common.item_lock_notification"
        }
      },
      {
        "root_panel@ultimate_crafting_table.ultimate_crafting_table_root_panel": {}
      }]
  }
}